#!/bin/sh
## File:     selforg-config for libselforg
## Author:   Georg Martius 
## Date:     Oct 2011

define(`COMMENT', )
COMMENT(`There are defines for platform dependend stuff.
         DEV only produces output in the development version
         DEVORUSER  choice between development (first argument) or user (second)
         LINUXORMAC outputs the first argument on linux and the second on mac.
         GSL outputs the first argument of GSL is used or second if not
         Call the m4 processor with -D PREFIX=... -D SRCPREFIX=... 
                                    -D MAC|LINUX -D DEVEL|USER -D VERSION=...
                                    [-D NOGSL]
         The SRCPREFIX is only requried for DEVEL
         ')
COMMENT(`Comment for processed file:')
# Do not edit, this is file generated by m4 from selforg-config.m4

ifdef(`DEVEL', 
`define(`DEVORUSER', $1) define(`DEV', $1)'
,
`define(`DEVORUSER', $2) define(`DEV',)'
)
ifdef(`MAC', 
`define(`LINUXORMAC', $2)'
,
`define(`LINUXORMAC', $1)'
)
ifdef(`NOGSL', `define(`GSL', $2)',`define(`GSL', $1)')
COMMENT(`change quote syntax to [[string]]')
changequote([[,]]) 

prefix="PREFIX"
srcprefix="SRCPREFIX"
intern=
type=DEVORUSER([[[[DEVEL]]]],[[[[USER]]]])

LIBBASE=selforg

## use -pg for profiling
CBASEFLAGS="-pthread LINUXORMAC( ,-I/opt/local/include)" 
CPPFLAGS="$CBASEFLAGS"
INTERNFLAGS="-g -O"
LIBS="-lm -lreadline -lncurses -lpthread"
STATIC=

usage="\
Usage: selforg-config [--prefix[=DIR]] [--srcprefix[=DIR]] [--version] [--intern] [--static] [--opt|--dbg] [--cflags] [--libs] [--libfile] [--solibfile] [--type]"

if test $# -eq 0; then
      echo "${usage}" 1>&2
      exit 1
fi

while test $# -gt 0; do
  case "$1" in
  -*=*) optarg=`echo "$1" | sed 's/[-_a-zA-Z0-9]*=//'` ;;
  *) optarg= ;;
  esac

  case $1 in
    --type)
      echo $type
      exit 0
      ;;
    --prefix=*)
      prefix=$optarg
      ;;
    --prefix)
      echo $prefix
      ;;
    --srcprefix=*)
      srcprefix=$optarg
      ;;
    --srcprefix)
      echo $srcprefix
      ;;
    --version)
      echo VERSION
      ;;
    --intern) ##for internal use when compiling the lib
      intern=1
      ;;
    --static) ##force use static linking of lib
      STATIC=--static
      STATICSTART=-Wl,-Bstatic
      STATICEND=-Wl,-Bdynamic
    ;;
    --opt) ##Optimisation
      LIBBASE=${LIBBASE}_opt
      CPPFLAGS="$CBASEFLAGS -DNDEBUG"
      INTERNFLAGS="-O3"
      ;;
    --dbg) ## DEBUG      
      LIBBASE=${LIBBASE}_dbg
      CPPFLAGS="$CBASEFLAGS -g"
      INTERNFLAGS="-g"
      ;;
    --cflags)
      if [ -z "$intern" ]; then INTERNFLAGS=; fi
      if type configurator-config >/dev/null 2>&1; then
        CONFIGURATORCLAGS=`configurator-config $STATIC --cflags`;
      else
        CONFIGURATORCLAGS=-DNOCONFIGURATOR
      fi                                     
      echo $CPPFLAGS DEVORUSER(-I"$srcprefix/include",-I"$prefix/include") LINUXORMAC( ,-I/opt/local/include) GSL(`gsl-config --cflags`, -DNO_GSL) $CONFIGURATORCLAGS $INTERNFLAGS
      ;;
    --libs)
      if type configurator-config >/dev/null 2>&1; then
        CONFIGURATORLIBS=`configurator-config $STATIC --libs`;
      fi                                     
      echo $LIBS DEVORUSER(-L"$srcprefix/",-L"$prefix/lib") $STATICSTART -l$LIBBASE $STATICEND GSL(`gsl-config --libs`,) $CONFIGURATORLIBS
      ;;
    --libfile)
      echo "$srcprefix/lib${LIBBASE}.a"
      ;;
    --solibfile)
      echo "$srcprefix/lib${LIBBASE}.so"
      ;;
    *)
      echo "Syntax Error: $0 $@" 1>&2
      echo "${usage}" 1>&2
      exit 1
      ;;
  esac
  shift
done
